diff --git a/Client/Client/Assets/Scenes/WebGL.unity b/Client/Client/Assets/Scenes/WebGL.unity
index a372859..63b71ea 100644
--- a/Client/Client/Assets/Scenes/WebGL.unity
+++ b/Client/Client/Assets/Scenes/WebGL.unity
@@ -14055,6 +14735,81 @@ CanvasRenderer:
   m_PrefabAsset: {fileID: 0}
   m_GameObject: {fileID: 1786877489}
   m_CullTransparentMesh: 0
+--- !u!1 &1787543483
+GameObject:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  serializedVersion: 6
+  m_Component:
+  - component: {fileID: 1787543486}
+  - component: {fileID: 1787543485}
+  - component: {fileID: 1787543484}
+  m_Layer: 5
+  m_Name: OpenAbout
+  m_TagString: Untagged
+  m_Icon: {fileID: 0}
+  m_NavMeshLayer: 0
+  m_StaticEditorFlags: 0
+  m_IsActive: 1
+--- !u!114 &1787543484
+MonoBehaviour:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1787543483}
+  m_Enabled: 0
+  m_EditorHideFlags: 0
+  m_Script: {fileID: 11500000, guid: fe87c0e1cc204ed48ad3b37840f39efc, type: 3}
+  m_Name: 
+  m_EditorClassIdentifier: 
+  m_Material: {fileID: 0}
+  m_Color: {r: 0.8980393, g: 0.9058824, b: 0.9176471, a: 1}
+  m_RaycastTarget: 1
+  m_Maskable: 1
+  m_OnCullStateChanged:
+    m_PersistentCalls:
+      m_Calls: []
+  m_Sprite: {fileID: 21300000, guid: 915f428a07576ec41a126a3bb514df20, type: 3}
+  m_Type: 1
+  m_PreserveAspect: 0
+  m_FillCenter: 1
+  m_FillMethod: 4
+  m_FillAmount: 1
+  m_FillClockwise: 1
+  m_FillOrigin: 0
+  m_UseSpriteMesh: 0
+  m_PixelsPerUnitMultiplier: 1
+--- !u!222 &1787543485
+CanvasRenderer:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1787543483}
+  m_CullTransparentMesh: 0
+--- !u!224 &1787543486
+RectTransform:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1787543483}
+  m_LocalRotation: {x: 0, y: 0, z: 0, w: 1}
+  m_LocalPosition: {x: 0, y: 0, z: 0}
+  m_LocalScale: {x: 0.9, y: 0.9, z: 1}
+  m_Children:
+  - {fileID: 1421962609}
+  m_Father: {fileID: 1293201332}
+  m_RootOrder: 4
+  m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
+  m_AnchorMin: {x: 0, y: 1}
+  m_AnchorMax: {x: 1, y: 1}
+  m_AnchoredPosition: {x: 0, y: -677}
+  m_SizeDelta: {x: 0, y: 100}
+  m_Pivot: {x: 0.5, y: 1}
 --- !u!1 &1794286522
 GameObject:
   m_ObjectHideFlags: 0
@@ -14163,7 +14918,7 @@ RectTransform:
   m_LocalScale: {x: 1, y: 1, z: 1}
   m_Children: []
   m_Father: {fileID: 950576583}
-  m_RootOrder: 5
+  m_RootOrder: 0
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0, y: 0}
   m_AnchorMax: {x: 0, y: 1}
@@ -14457,7 +15212,7 @@ MonoBehaviour:
     m_HorizontalOverflow: 0
     m_VerticalOverflow: 0
     m_LineSpacing: 1
-  m_Text: CLEAR WEATHER
+  m_Text: CLEAR INPUT WEATHER
 --- !u!222 &1864300439
 CanvasRenderer:
   m_ObjectHideFlags: 0
@@ -14936,7 +15691,7 @@ RectTransform:
   m_Children:
   - {fileID: 528733866}
   m_Father: {fileID: 1424664561}
-  m_RootOrder: 2
+  m_RootOrder: 3
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0.5, y: 0}
   m_AnchorMax: {x: 0.5, y: 0}
@@ -15192,81 +15947,6 @@ CanvasRenderer:
   m_PrefabAsset: {fileID: 0}
   m_GameObject: {fileID: 1966892021}
   m_CullTransparentMesh: 0
---- !u!1 &1983551431
-GameObject:
-  m_ObjectHideFlags: 0
-  m_CorrespondingSourceObject: {fileID: 0}
-  m_PrefabInstance: {fileID: 0}
-  m_PrefabAsset: {fileID: 0}
-  serializedVersion: 6
-  m_Component:
-  - component: {fileID: 1983551432}
-  - component: {fileID: 1983551434}
-  - component: {fileID: 1983551433}
-  m_Layer: 5
-  m_Name: ResetBuilding
-  m_TagString: Untagged
-  m_Icon: {fileID: 0}
-  m_NavMeshLayer: 0
-  m_StaticEditorFlags: 0
-  m_IsActive: 1
---- !u!224 &1983551432
-RectTransform:
-  m_ObjectHideFlags: 0
-  m_CorrespondingSourceObject: {fileID: 0}
-  m_PrefabInstance: {fileID: 0}
-  m_PrefabAsset: {fileID: 0}
-  m_GameObject: {fileID: 1983551431}
-  m_LocalRotation: {x: 0, y: 0, z: 0, w: 1}
-  m_LocalPosition: {x: 0, y: 0, z: 0}
-  m_LocalScale: {x: 0.9, y: 0.9, z: 1}
-  m_Children:
-  - {fileID: 769891717}
-  m_Father: {fileID: 1293201332}
-  m_RootOrder: 7
-  m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
-  m_AnchorMin: {x: 0, y: 1}
-  m_AnchorMax: {x: 1, y: 1}
-  m_AnchoredPosition: {x: 0, y: -568}
-  m_SizeDelta: {x: 0, y: 100}
-  m_Pivot: {x: 0.5, y: 1}
---- !u!114 &1983551433
-MonoBehaviour:
-  m_ObjectHideFlags: 0
-  m_CorrespondingSourceObject: {fileID: 0}
-  m_PrefabInstance: {fileID: 0}
-  m_PrefabAsset: {fileID: 0}
-  m_GameObject: {fileID: 1983551431}
-  m_Enabled: 0
-  m_EditorHideFlags: 0
-  m_Script: {fileID: 11500000, guid: fe87c0e1cc204ed48ad3b37840f39efc, type: 3}
-  m_Name: 
-  m_EditorClassIdentifier: 
-  m_Material: {fileID: 0}
-  m_Color: {r: 0.8980393, g: 0.9058824, b: 0.9176471, a: 1}
-  m_RaycastTarget: 1
-  m_Maskable: 1
-  m_OnCullStateChanged:
-    m_PersistentCalls:
-      m_Calls: []
-  m_Sprite: {fileID: 21300000, guid: 915f428a07576ec41a126a3bb514df20, type: 3}
-  m_Type: 1
-  m_PreserveAspect: 0
-  m_FillCenter: 1
-  m_FillMethod: 4
-  m_FillAmount: 1
-  m_FillClockwise: 1
-  m_FillOrigin: 0
-  m_UseSpriteMesh: 0
-  m_PixelsPerUnitMultiplier: 1
---- !u!222 &1983551434
-CanvasRenderer:
-  m_ObjectHideFlags: 0
-  m_CorrespondingSourceObject: {fileID: 0}
-  m_PrefabInstance: {fileID: 0}
-  m_PrefabAsset: {fileID: 0}
-  m_GameObject: {fileID: 1983551431}
-  m_CullTransparentMesh: 0
 --- !u!1 &1984542443
 GameObject:
   m_ObjectHideFlags: 0
@@ -15659,7 +16339,7 @@ RectTransform:
   - {fileID: 1647108324}
   - {fileID: 233731343}
   m_Father: {fileID: 593557251}
-  m_RootOrder: 0
+  m_RootOrder: 1
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0.5, y: 1}
   m_AnchorMax: {x: 0.5, y: 1}
@@ -15716,7 +16396,7 @@ GameObject:
   - component: {fileID: 2014947978}
   - component: {fileID: 2014947977}
   m_Layer: 5
-  m_Name: Button
+  m_Name: ExitButton
   m_TagString: Untagged
   m_Icon: {fileID: 0}
   m_NavMeshLayer: 0
@@ -15733,12 +16413,12 @@ RectTransform:
   m_LocalPosition: {x: 0, y: 0, z: 0}
   m_LocalScale: {x: 1, y: 1, z: 1}
   m_Children: []
-  m_Father: {fileID: 660500495}
-  m_RootOrder: 1
+  m_Father: {fileID: 1424664561}
+  m_RootOrder: 0
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 1, y: 1}
   m_AnchorMax: {x: 1, y: 1}
-  m_AnchoredPosition: {x: -51.25, y: -51.25}
+  m_AnchoredPosition: {x: -20, y: -20}
   m_SizeDelta: {x: 25, y: 25}
   m_Pivot: {x: 1, y: 1}
 --- !u!114 &2014947977
@@ -16666,7 +17346,7 @@ RectTransform:
   m_Children:
   - {fileID: 345387603}
   m_Father: {fileID: 1450781057}
-  m_RootOrder: 1
+  m_RootOrder: 2
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0.5, y: 1}
   m_AnchorMax: {x: 0.5, y: 1}
@@ -16914,7 +17594,7 @@ RectTransform:
   m_Children:
   - {fileID: 988903610}
   m_Father: {fileID: 1450781057}
-  m_RootOrder: 0
+  m_RootOrder: 1
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0.5, y: 1}
   m_AnchorMax: {x: 0.5, y: 1}
diff --git a/Client/Client/Assets/Scripts/MapRenderer.cs b/Client/Client/Assets/Scripts/MapRenderer.cs
index cc41b53..7f5450b 100644
--- a/Client/Client/Assets/Scripts/MapRenderer.cs
+++ b/Client/Client/Assets/Scripts/MapRenderer.cs
@@ -31,6 +31,8 @@ public class MapRenderer : MonoBehaviour
 
     private Dictionary<string, SpriteRenderer> overlay = new Dictionary<string, SpriteRenderer>();
 
+    private bool first = true;
+
 
     // Start is called before the first frame update
     void Start()
@@ -42,6 +44,67 @@ public class MapRenderer : MonoBehaviour
         interactable = true;
     }
 
+    void Update()
+    {
+        if (first)
+        {
+            first = false;
+
+            // Get source directory
+            string sourceDirectory = sceneManager.mapSourceDirectory;
+
+            // Get file with asset relative positions
+            TextAsset output = Resources.Load<TextAsset>($"{sourceDirectory}/output");
+
+            if (output == null)
+            {
+                Debug.Log($"Layout file missing at {sourceDirectory}/output.csv. Returning.");
+                return;
+            }
+
+            string[] lines = output.ToString().Split('\n');
+            List<string> filenamesTMP = new List<string>();
+
+            for (int i = 0; i < lines.Length; i++)
+            {
+                lines[i] = lines[i].Trim();
+                if (lines[i].Length != 0 && !lines[i].StartsWith("//"))
+                    filenamesTMP.Add(lines[i]);
+            }
+
+            lines = filenamesTMP.ToArray();
+
+            for (int i = 0; i < lines.Length; i++)
+            {
+                var split = lines[i].Split(';');
+
+                // Parse name minus the extension
+                // X - percent offset from left btm corner
+                // Y - percent offset from left btm corner
+                var name = split[0].Substring(0, split[0].Length - 4);
+                var xoff = float.Parse(split[1]);
+                var yoff = float.Parse(split[2]);
+
+                var img = overlay[name];
+
+                if (img != null)
+                {
+                    var bounds = underlay.bounds;
+                    var imgbounds = img.bounds;
+
+                    var xshift = -bounds.size.x / 2 + imgbounds.size.x / 2 + bounds.size.x * (xoff / 100);
+                    var yshift = -bounds.size.y / 2 + imgbounds.size.y / 2 + bounds.size.y * (yoff / 100);
+
+                    img.gameObject.transform.position = bounds.center + new Vector3(xshift, yshift, 0);
+                }
+                else
+                {
+                    Debug.Log($"Error: Missing sprite {name}!");
+                }
+            }
+        }
+    }
+
     /// <summary>
     /// Loads map resources from an annotated directory
     /// A "layout.txt" file with directory annotation is required
diff --git a/Client/Client/Assets/Scripts/NetworkingManager.cs b/Client/Client/Assets/Scripts/NetworkingManager.cs
index 2827fda..be012be 100644
--- a/Client/Client/Assets/Scripts/NetworkingManager.cs
+++ b/Client/Client/Assets/Scripts/NetworkingManager.cs
@@ -15,7 +15,7 @@ public class NetworkingManager : MonoBehaviour
         StartCoroutine(Post(uri, XmlCommunication.Serialize(request)));
 
         // Mock response:
-        StartCoroutine(Get(uri));
+        // StartCoroutine(Get(uri));
     }
 
     public void StartGet()
@@ -23,6 +23,11 @@ public class NetworkingManager : MonoBehaviour
         StartCoroutine(Get(uri));
     }
 
+    public void StartWeatherGet(WeatherProvider weatherProvider, string uri)
+    {
+        StartCoroutine(WeatherGet(weatherProvider, uri));
+    }
+
     IEnumerator Post(string uri, string toPost)
     {
         Debug.Log("Uploading: " + toPost);
@@ -36,7 +41,16 @@ public class NetworkingManager : MonoBehaviour
         }
         else
         {
+            // Show results as text
             Debug.Log("Upload complete!");
+
+            var xml = www.downloadHandler.text;
+
+            Debug.Log(xml);
+
+            rushManager.SetResponse(XmlCommunication.Deserialize<Response>(xml));
+
+            Debug.Log("Response received!");
         }
     }
 
@@ -60,6 +74,26 @@ public class NetworkingManager : MonoBehaviour
         }
     }
 
+    IEnumerator WeatherGet(WeatherProvider weatherProvider, string uri)
+    {
+        Debug.Log("Downloading weather...");
+        UnityWebRequest www = UnityWebRequest.Get(uri);
+        www.certificateHandler = new AcceptAllCertificates();
+        yield return www.SendWebRequest();
+
+        if (www.isNetworkError || www.isHttpError)
+        {
+            Debug.Log(www.error);
+        }
+        else
+        {
+            // Show results as text
+            var weather = www.downloadHandler.text;
+            weatherProvider.LoadFromResponse(weather);
+            Debug.Log(weather);
+        }
+    }
+
     public class AcceptAllCertificates : CertificateHandler
     {
         protected override bool ValidateCertificate(byte[] certificateData)
diff --git a/Client/Client/Assets/Scripts/SceneManager.cs b/Client/Client/Assets/Scripts/SceneManager.cs
index 99e9cde..fa698d2 100644
--- a/Client/Client/Assets/Scripts/SceneManager.cs
+++ b/Client/Client/Assets/Scripts/SceneManager.cs
@@ -11,6 +11,7 @@ public class SceneManager : MonoBehaviour
     public GameObject datePanel;
     public GameObject buildingPanel;
     public GameObject animationPanel;
+    public GameObject aboutPanel;
 
     public bool first;
 
@@ -22,6 +23,7 @@ public class SceneManager : MonoBehaviour
         datePanel.SetActive(true);
         buildingPanel.SetActive(true);
         animationPanel.SetActive(true);
+        aboutPanel.SetActive(true);
     }
 
     // Update is called once per frame
@@ -33,6 +35,7 @@ public class SceneManager : MonoBehaviour
             datePanel.SetActive(false);
             buildingPanel.SetActive(false);
             animationPanel.SetActive(false);
+            aboutPanel.SetActive(false);
             first = false;
         }
     }
diff --git a/Client/Client/Assets/Scripts/UI/BuildingPanel.cs b/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
index c195359..5bb45de 100644
--- a/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
@@ -6,23 +6,10 @@ using UnityEngine.UI;
 public class BuildingPanel : PopUpPanel
 {
     public Button setBuildingButton;
-    public Button unsetBuildingButton;
-
-    public Image mockBuilding;
 
     public void OnSetBuildingButton()
     {
-        setBuildingButton.gameObject.SetActive(false);
-        unsetBuildingButton.gameObject.SetActive(true);
-        mockBuilding.gameObject.SetActive(true);
         OnExitButtonClicked();
     }
 
-    public void OnUnsetBuildingButton()
-    {
-        setBuildingButton.gameObject.SetActive(true);
-        unsetBuildingButton.gameObject.SetActive(false);
-        mockBuilding.gameObject.SetActive(false);
-    }
-
 }
diff --git a/Client/Client/Assets/Scripts/UI/DatePanel.cs b/Client/Client/Assets/Scripts/UI/DatePanel.cs
index 54e5262..2262efd 100644
--- a/Client/Client/Assets/Scripts/UI/DatePanel.cs
+++ b/Client/Client/Assets/Scripts/UI/DatePanel.cs
@@ -38,7 +38,6 @@ public class DatePanel : PopUpPanel
             endMM.interactable = true;
             endYYYY.interactable = true;
             endHH.interactable = true;
-            button.GetComponentInChildren<Text>().text = "VIEW TIMESPAN";
         }
         else
         {
@@ -46,7 +45,6 @@ public class DatePanel : PopUpPanel
             endMM.interactable = false;
             endYYYY.interactable = false;
             endHH.interactable = false;
-            button.GetComponentInChildren<Text>().text = "VIEW TIME";
         }
     }
 
diff --git a/Client/Client/Assets/Scripts/UI/SidePanel.cs b/Client/Client/Assets/Scripts/UI/SidePanel.cs
index 271bc3a..0a568db 100644
--- a/Client/Client/Assets/Scripts/UI/SidePanel.cs
+++ b/Client/Client/Assets/Scripts/UI/SidePanel.cs
@@ -14,6 +14,7 @@ public class SidePanel : MonoBehaviour
     public GameObject weatherPanel;
     public GameObject datePanel;
     public GameObject builidngPanel;
+    public GameObject aboutPanel;
 
     public Button weatherButton;
     public Button resetWeatherButton;
@@ -23,6 +24,8 @@ public class SidePanel : MonoBehaviour
     public void OnWeatherPanelClicked() => OpenPanel(weatherPanel);
 
     public void OnBuildingPanelClicked() => OpenPanel(builidngPanel);
+    
+    public void OnAboutPanelClicked() => OpenPanel(aboutPanel);
 
     public void OnDatePanelClicked()
     {
@@ -46,6 +49,7 @@ public class SidePanel : MonoBehaviour
         weatherPanel.SetActive(false);
         datePanel.SetActive(false);
         builidngPanel.SetActive(false);
+        aboutPanel.SetActive(false);
         popup.SetActive(true);
     }
 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs
index 31c8058..eacf163 100644
--- a/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs
+++ b/Client/Client/Assets/Scripts/Weather/Parser/IJsonParser.cs
@@ -25,7 +25,7 @@ namespace ServerApp.WeatherPredictionParser
         /// Parse weather prediction
         /// Results is in attributes current for current weather and pred for weather prediction for today, tommorrow and day after tommorrow
         /// </summary>
-        abstract public void ParsePrediction();
+        abstract public void ParsePrediction(string file);
 
     }
 
diff --git a/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs
index 5a860b4..42ad425 100644
--- a/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs
+++ b/Client/Client/Assets/Scripts/Weather/Parser/JsonParser.cs
@@ -52,34 +52,39 @@ namespace ServerApp.WeatherPredictionParser
         /// <returns> Path to file </returns>
         private string DownloadWeatherPrediction()
         {
-            DateTime now = DateTime.Now;
-            WebClient webClient = new WebClient();
-            webClient.DownloadFile(pathToFile, $"data/{now.Year}{now.Month}{now.Day}.json");
+            //DateTime now = DateTime.Now;
+            //WebClient webClient = new WebClient();
+
+            //if (!Directory.Exists("data"))
+            //    Directory.CreateDirectory("data");
+
+            //webClient.DownloadFile(pathToFile, $"data/{now.Year}{now.Month}{now.Day}.json");
 
-            return $"data/{now.Year}{now.Month}{now.Day}.json";
+            //return $"data/{now.Year}{now.Month}{now.Day}.json";
+
+            return "";
         }
 
         /// <summary>
         /// Parse weather prediction
         /// Results is in attributes current for current weather and pred for weather prediction for today, tommorrow and day after tommorrow
         /// </summary>
-        override public void ParsePrediction()
+        override public void ParsePrediction(string data)
         {
             // TODO ask DataDownloader for download said file and return path to it
             
             // get file
-            string file = DownloadWeatherPrediction();
             DateTime now = DateTime.Now;
-            Console.WriteLine(File.Exists(file));
+            // Console.WriteLine(File.Exists(file));
 
             current = new WeatherInfo();
             predictions = new List<WeatherInfo>();
 
-            if (!File.Exists(file))
-                return;
-
-            // read file
-            string data = File.ReadAllText(file);
+            // if (!File.Exists(file))
+            //     return;
+            // 
+            // // read file
+            // string data = File.ReadAllText(file);
 
             // parse
             JsonDocument doc = JsonDocument.Parse(data);
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherData.cs b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
index 21e2c28..9eda53a 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherData.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherData.cs
@@ -19,6 +19,8 @@ public class WeatherData
         Rain = rain;
         Weather = weather;
 
+        Debug.Log($"Setting: tmp={temperature}, wind={wind}, rain={rain}, weather={weather}");
+
         foreach (var observer in observers)
             observer.Notify(this);
     }
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
index b292449..999988d 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
@@ -7,6 +7,7 @@ using UnityEngine.UI;
 
 public class WeatherManager : MonoBehaviour, WeatherObserver
 {
+    public NetworkingManager networkingManager;
     public WeatherProvider provider;
     public WeatherData data;
 
@@ -22,7 +23,7 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
         data = new WeatherData();
         data.RegisterObserver(this);
 
-        provider = new WeatherProvider(data);
+        provider = new WeatherProvider(data, networkingManager);
         provider.Load();
     }
 
@@ -63,7 +64,7 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
 
     public void Clear()
     {
-        provider = new WeatherProvider(data);
+        provider = new WeatherProvider(data, networkingManager);
         provider.Load();
     }
 }
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
index b3d00a6..6e9c42f 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
@@ -1,36 +1,47 @@
-﻿using ServerApp.WeatherPredictionParser;
+﻿using ServerApp.Parser.OutputInfo;
+using ServerApp.WeatherPredictionParser;
 using System.Collections;
 using System.Collections.Generic;
 using UnityEngine;
 
 public class WeatherProvider
 {
-    private WeatherData data;
+    public NetworkingManager networkingManager;
+    public string uri = "https://wttr.in/Plzen,czechia?format=j1";
 
-    JsonParser parser = new JsonParser("http://wttr.in/Plzen,czechia?format=j1");
+    private JsonParser parser;
+    private WeatherData data;
 
-    public WeatherProvider(WeatherData data)
+    public WeatherProvider(WeatherData data, NetworkingManager networkingManager)
     {
         this.data = data;
+        this.networkingManager = networkingManager;
+        parser = new JsonParser(uri);
     }
 
     public void Load()
     {
-        //var temperature = Random.Range(-10f, 30f);
-        //var wind = Random.Range(0f, 20f);
-        //var rain = Random.Range(0f, 100f);
-        //var weather = (WeatherCondition)Random.Range(0, 3);
+        networkingManager.StartWeatherGet(this, uri);
+    }
+
+    public void LoadFromResponse(string response)
+    {
+        Debug.Log("Parsing...");
 
-        parser.ParsePrediction();
+        parser.ParsePrediction(response);
         var current = parser.Current;
-        
+
+        Debug.Log("Parsed.");
+
         if (current != null)
         {
             var temperature = current.temp;
             var rain = current.rain;
             var wind = current.wind;
             var weather = current.condition;
-            
+
+            Debug.Log($"Wanna set: tmp={temperature}, wind={wind}, rain={rain}, weather={weather}");
+
             data.SetValues(temperature, wind, rain, weather);
         }
         else
diff --git a/Client/Client/Assets/Scripts/WebGLMapController.cs b/Client/Client/Assets/Scripts/WebGLMapController.cs
index 436e17c..cd63d19 100644
--- a/Client/Client/Assets/Scripts/WebGLMapController.cs
+++ b/Client/Client/Assets/Scripts/WebGLMapController.cs
@@ -19,11 +19,17 @@ public class WebGLMapController : MonoBehaviour
 	[SerializeField]
 	private float maxScale = 1f;
 
+	private Vector3 originalPos;
 	private Vector3 screenPoint;
 	private Vector3 offset;
 
 	private bool block;
 
+	void Start()
+	{
+		originalPos = map.transform.position;
+	}
+
 	void Update()
 	{
 		ClampPan();
@@ -58,17 +64,21 @@ public class WebGLMapController : MonoBehaviour
 		if (EventSystem.current.IsPointerOverGameObject())
 			return;
 
-		var scroll = Input.mouseScrollDelta.y;
-		float diff = Time.deltaTime * zoomSpeed;
+		var scroll = Input.mouseScrollDelta.y;		
+		float step = Time.deltaTime * zoomSpeed;
 		float scale = map.transform.localScale.x;
 
+		var xnorm = map.transform.position.x / scale;
+		var ynorm = map.transform.position.y / scale;
+
 		if (scroll > 0)
-			scale = ClampScale(scale + diff);
+			scale = ClampScale(scale + step);
 		else if (scroll < 0)
-			scale = ClampScale(scale - diff);
-
+			scale = ClampScale(scale - step);
+		
 		Vector3 localScale = new Vector3(scale, scale, 1);
 		map.transform.localScale = localScale;
+		map.transform.position = new Vector3(xnorm * scale, ynorm * scale, map.transform.position.z);
 
 		ClampPan();
 	}
@@ -81,7 +91,7 @@ public class WebGLMapController : MonoBehaviour
     private void ClampPan()
 	{
 		var bounds = map.transform.Find("Underlay").GetComponent<SpriteRenderer>().sprite.bounds;
-		bounds = TransformBounds(bounds);
+		bounds = TransformBounds(bounds, map.transform.localScale);
 
 		var screenMin = Camera.main.WorldToScreenPoint(bounds.min + map.transform.position);
 		var screenMax = Camera.main.WorldToScreenPoint(bounds.max + map.transform.position);
@@ -89,22 +99,61 @@ public class WebGLMapController : MonoBehaviour
 		float shiftX = 0f;
 		float shiftY = 0f;
 
-		if (screenMin.x > 0)
-			shiftX -= screenMin.x;
+		var mapWidth = screenMax.x - screenMin.x;
+		var mapHeight = screenMax.y - screenMin.y;
 
-		if (screenMin.y > 0)
-			shiftY -= screenMin.y;
+		bool wider = mapWidth >= Camera.main.pixelWidth;
+		bool taller = mapHeight >= Camera.main.pixelHeight;
 
-		if (screenMax.x < Camera.main.pixelWidth)
-			shiftX += Camera.main.pixelWidth - screenMax.x;
+		if (wider)
+        {
+			if (screenMin.x > 0)
+				shiftX -= screenMin.x;
+
+			if (screenMax.x < Camera.main.pixelWidth)
+				shiftX += Camera.main.pixelWidth - screenMax.x;
+		}
 
-		if (screenMax.y < Camera.main.pixelHeight)
-			shiftY += Camera.main.pixelHeight - screenMax.y;
+		if (taller)
+		{
+			if (screenMin.y > 0)
+				shiftY -= screenMin.y;
+
+			if (screenMax.y < Camera.main.pixelHeight)
+				shiftY += Camera.main.pixelHeight - screenMax.y;
+		}
 
 		var screenCenter = Camera.main.WorldToScreenPoint(map.transform.position);
 		screenCenter.x += shiftX;
 		screenCenter.y += shiftY;
 		map.transform.position = Camera.main.ScreenToWorldPoint(screenCenter);
+
+		if (wider && taller)
+        {
+			// Nothing to do, the position is correct
+		}
+		else if (taller)
+        {
+			// Set original x coord
+			map.transform.position = new Vector3(
+				originalPos.x,
+				map.transform.position.y,
+				map.transform.position.z);
+		}
+		else if (wider)
+        {
+			// Set original y coord
+			map.transform.position = new Vector3(
+				map.transform.position.x,
+				originalPos.y,
+				map.transform.position.z);
+		}
+		else
+        {
+			// Set original position but this should not happen
+			map.transform.position = originalPos;
+		}
+		
 	}
 
 	private float ClampScale(float scale)
@@ -112,10 +161,9 @@ public class WebGLMapController : MonoBehaviour
 		return Mathf.Min(Mathf.Max(scale, minScale), maxScale);
 	}
 
-	private Bounds TransformBounds(Bounds bounds)
+	private Bounds TransformBounds(Bounds bounds, Vector3 scale)
 	{
 		var size = bounds.size;
-		var scale = map.transform.localScale;
 
 		size.x *= scale.x;
 		size.y *= scale.y;
